version: "3"

services:

  wireguard:
    image: linuxserver/wireguard:{{ wireguard_version }}
    cap_add:
      - NET_ADMIN
    volumes:
      - {{ wireguard_data }}:/config
      - {{ wireguard_ui_data }}/config:/config/wg_confs/
    ports:
      # Port of the WireGuard VPN server 51820
      - "{{ wireguard_port }}:51820/udp"
    restart: unless-stopped
    networks:
      dnsnet:
        ipv4_address: {{ wireguard_internal_ip }}
    

  wireguard-ui:
    image: ngoduykhanh/wireguard-ui:{{ wireguard_ui_version }}
    depends_on:
      - wireguard
    restart: unless-stopped
    environment:
      - WGUI_USERNAME={{ wireguard_ui_username }}
      - WGUI_PASSWORD={{ wireguard_ui_password }}
      - WGUI_MANAGE_START=false
      - WGUI_MANAGE_RESTART=false
      - WGUI_DEFAULT_CLIENT_USE_SERVER_DNS=true
      - WGUI_DNS={{ pihole_internal_ip }}
      - WGUI_ENDPOINT_ADDRESS={{ wireguard_domain }}
      - WGUI_SERVER_POST_UP_SCRIPT=iptables -A FORWARD -i wg0 -j ACCEPT; iptables -t nat -A POSTROUTING -o eth0 -j MASQUERADE
      - WGUI_SERVER_POST_DOWN_SCRIPT=iptables -D FORWARD -i wg0 -j ACCEPT; iptables -t nat -D POSTROUTING -o eth0 -j MASQUERADE
    networks:
      web:
    labels:
      - "traefik.enable=true"
      - "traefik.docker.network=web"
      - "traefik.http.routers.wireguard.entrypoints=websecure"
      - "traefik.http.routers.wireguard.rule=Host(`{{ wireguard_domain }}`)"
      - "traefik.http.routers.wireguard.tls.certresolver=httpsresolver"
      - "traefik.http.services.wireguard.loadbalancer.server.port=5000"
    logging:
      driver: json-file
      options:
        max-size: 50m
    volumes:
      - {{ wireguard_ui_data }}/db:/app/db
      - {{ wireguard_ui_data }}/config:/etc/wireguard

  pihole:
    image: pihole/pihole:{{ pihole_version }}
    environment:
      TZ: '{{ timezone }}'
      WEBPASSWORD: '{{ pihole_admin_password }}'
    volumes:
      - '{{ pihole_data }}/etc-pihole:/etc/pihole'
      - '{{ pihole_data }}/etc-dnsmasq.d:/etc/dnsmasq.d'
    restart: unless-stopped
    networks:
      dnsnet:
        ipv4_address: {{ pihole_internal_ip }}


networks:
  dnsnet:
    ipam:
      driver: default
      config:
        - subnet: {{ subnet }}
  web:
    external: true

